// ************************************************************************ //
// The types declared in this file were generated from data read from the
// WSDL File described below:
// WSDL     : https://ws.ankarasigorta.com.tr/CustomerWS.svc?singleWsdl
//  >Import : https://ws.ankarasigorta.com.tr/CustomerWS.svc?singleWsdl>0
//  >Import : https://ws.ankarasigorta.com.tr/CustomerWS.svc?singleWsdl>1
//  >Import : https://ws.ankarasigorta.com.tr/CustomerWS.svc?singleWsdl>2
//  >Import : https://ws.ankarasigorta.com.tr/CustomerWS.svc?singleWsdl>3
// Encoding : utf-8
// Version  : 1.0
// (6.05.2021 13:54:26 - - $Rev: 90173 $)
// ************************************************************************ //

unit CustomerWS;

interface

uses Soap.InvokeRegistry, Soap.SOAPHTTPClient, System.Types, Soap.XSBuiltIns;

const
  IS_OPTN = $0001;
  IS_UNBD = $0002;
  IS_NLBL = $0004;
  IS_REF  = $0080;


type

  // ************************************************************************ //
  // The following types, referred to in the WSDL document are not being represented
  // in this file. They are either aliases[@] of other types represented or were referred
  // to but never[!] declared in the document. The types from the latter category
  // typically map to predefined/known XML or Embarcadero types; however, they could also 
  // indicate incorrect WSDL documents that failed to declare or import a schema type.
  // ************************************************************************ //
  // !:long            - "http://www.w3.org/2001/XMLSchema"[Gbl]
  // !:int             - "http://www.w3.org/2001/XMLSchema"[Gbl]
  // !:string          - "http://www.w3.org/2001/XMLSchema"[Gbl]
  // !:dateTime        - "http://www.w3.org/2001/XMLSchema"[Gbl]

  AnkaraFault          = class;                 { "http://ws.ankarasigorta.com.tr"[Flt][GblElm] }
  ErrorInfo2           = class;                 { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.Core.WS"[GblCplx] }
  ErrorInfo            = class;                 { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.Core.WS"[GblElm] }
  AnkaraFault2         = class;                 { "http://ws.ankarasigorta.com.tr"[GblCplx] }
  Address2             = class;                 { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models"[GblCplx] }
  Address              = class;                 { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models"[GblElm] }
  CustomerResult2      = class;                 { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models"[GblCplx] }
  CustomerResult       = class;                 { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models"[GblElm] }
  Customer2            = class;                 { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models"[GblCplx] }
  Customer             = class;                 { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models"[GblElm] }

  {$SCOPEDENUMS ON}
  { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models"[GblSmpl] }
  Gender = (None, Male, Female, Other);

  {$SCOPEDENUMS OFF}

  ArrayOfErrorInfo = array of ErrorInfo2;       { "http://schemas.datacontract.org/2004/07/AnkaraSigorta.Core.WS"[GblCplx] }


  // ************************************************************************ //
  // XML       : AnkaraFault, global, <element>
  // Namespace : http://ws.ankarasigorta.com.tr
  // Info      : Fault
  // Base Types: AnkaraFault
  // ************************************************************************ //
  AnkaraFault = class(ERemotableException)
  private
    FErrors: ArrayOfErrorInfo;
    FErrors_Specified: boolean;
    FMessage_: string;
    FMessage__Specified: boolean;
    procedure SetErrors(Index: Integer; const AArrayOfErrorInfo: ArrayOfErrorInfo);
    function  Errors_Specified(Index: Integer): boolean;
    procedure SetMessage_(Index: Integer; const Astring: string);
    function  Message__Specified(Index: Integer): boolean;
  public
    destructor Destroy; override;
  published
    property Errors:   ArrayOfErrorInfo  Index (IS_OPTN or IS_NLBL) read FErrors write SetErrors stored Errors_Specified;
    property Message_: string            Index (IS_OPTN or IS_NLBL) read FMessage_ write SetMessage_ stored Message__Specified;
  end;



  // ************************************************************************ //
  // XML       : ErrorInfo, global, <complexType>
  // Namespace : http://schemas.datacontract.org/2004/07/AnkaraSigorta.Core.WS
  // ************************************************************************ //
  ErrorInfo2 = class(TRemotable)
  private
    FCode: string;
    FCode_Specified: boolean;
    FMessage_: string;
    FMessage__Specified: boolean;
    procedure SetCode(Index: Integer; const Astring: string);
    function  Code_Specified(Index: Integer): boolean;
    procedure SetMessage_(Index: Integer; const Astring: string);
    function  Message__Specified(Index: Integer): boolean;
  published
    property Code:     string  Index (IS_OPTN or IS_NLBL) read FCode write SetCode stored Code_Specified;
    property Message_: string  Index (IS_OPTN or IS_NLBL) read FMessage_ write SetMessage_ stored Message__Specified;
  end;



  // ************************************************************************ //
  // XML       : ErrorInfo, global, <element>
  // Namespace : http://schemas.datacontract.org/2004/07/AnkaraSigorta.Core.WS
  // ************************************************************************ //
  ErrorInfo = class(ErrorInfo2)
  private
  published
  end;



  // ************************************************************************ //
  // XML       : AnkaraFault, global, <complexType>
  // Namespace : http://ws.ankarasigorta.com.tr
  // ************************************************************************ //
  AnkaraFault2 = class(TRemotable)
  private
    FErrors: ArrayOfErrorInfo;
    FErrors_Specified: boolean;
    FMessage_: string;
    FMessage__Specified: boolean;
    procedure SetErrors(Index: Integer; const AArrayOfErrorInfo: ArrayOfErrorInfo);
    function  Errors_Specified(Index: Integer): boolean;
    procedure SetMessage_(Index: Integer; const Astring: string);
    function  Message__Specified(Index: Integer): boolean;
  public
    destructor Destroy; override;
  published
    property Errors:   ArrayOfErrorInfo  Index (IS_OPTN or IS_NLBL) read FErrors write SetErrors stored Errors_Specified;
    property Message_: string            Index (IS_OPTN or IS_NLBL) read FMessage_ write SetMessage_ stored Message__Specified;
  end;



  // ************************************************************************ //
  // XML       : Address, global, <complexType>
  // Namespace : http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models
  // ************************************************************************ //
  Address2 = class(TRemotable)
  private
    FAcikAdres: string;
    FAcikAdres_Specified: boolean;
    FAda: string;
    FAda_Specified: boolean;
    FApartman: string;
    FApartman_Specified: boolean;
    FBina: string;
    FBina_Specified: boolean;
    FBlok: string;
    FBlok_Specified: boolean;
    FCadde: string;
    FCadde_Specified: boolean;
    FDaire: string;
    FDaire_Specified: boolean;
    FIl: string;
    FIl_Specified: boolean;
    FIlce: string;
    FIlce_Specified: boolean;
    FKat: string;
    FKat_Specified: boolean;
    FKoy: string;
    FKoy_Specified: boolean;
    FMahalle: string;
    FMahalle_Specified: boolean;
    FMahalleKodu: string;
    FMahalleKodu_Specified: boolean;
    FPafta: string;
    FPafta_Specified: boolean;
    FParsel: string;
    FParsel_Specified: boolean;
    FPostaKodu: string;
    FPostaKodu_Specified: boolean;
    FSayfa: string;
    FSayfa_Specified: boolean;
    FSite: string;
    FSite_Specified: boolean;
    FSokak: string;
    FSokak_Specified: boolean;
    procedure SetAcikAdres(Index: Integer; const Astring: string);
    function  AcikAdres_Specified(Index: Integer): boolean;
    procedure SetAda(Index: Integer; const Astring: string);
    function  Ada_Specified(Index: Integer): boolean;
    procedure SetApartman(Index: Integer; const Astring: string);
    function  Apartman_Specified(Index: Integer): boolean;
    procedure SetBina(Index: Integer; const Astring: string);
    function  Bina_Specified(Index: Integer): boolean;
    procedure SetBlok(Index: Integer; const Astring: string);
    function  Blok_Specified(Index: Integer): boolean;
    procedure SetCadde(Index: Integer; const Astring: string);
    function  Cadde_Specified(Index: Integer): boolean;
    procedure SetDaire(Index: Integer; const Astring: string);
    function  Daire_Specified(Index: Integer): boolean;
    procedure SetIl(Index: Integer; const Astring: string);
    function  Il_Specified(Index: Integer): boolean;
    procedure SetIlce(Index: Integer; const Astring: string);
    function  Ilce_Specified(Index: Integer): boolean;
    procedure SetKat(Index: Integer; const Astring: string);
    function  Kat_Specified(Index: Integer): boolean;
    procedure SetKoy(Index: Integer; const Astring: string);
    function  Koy_Specified(Index: Integer): boolean;
    procedure SetMahalle(Index: Integer; const Astring: string);
    function  Mahalle_Specified(Index: Integer): boolean;
    procedure SetMahalleKodu(Index: Integer; const Astring: string);
    function  MahalleKodu_Specified(Index: Integer): boolean;
    procedure SetPafta(Index: Integer; const Astring: string);
    function  Pafta_Specified(Index: Integer): boolean;
    procedure SetParsel(Index: Integer; const Astring: string);
    function  Parsel_Specified(Index: Integer): boolean;
    procedure SetPostaKodu(Index: Integer; const Astring: string);
    function  PostaKodu_Specified(Index: Integer): boolean;
    procedure SetSayfa(Index: Integer; const Astring: string);
    function  Sayfa_Specified(Index: Integer): boolean;
    procedure SetSite(Index: Integer; const Astring: string);
    function  Site_Specified(Index: Integer): boolean;
    procedure SetSokak(Index: Integer; const Astring: string);
    function  Sokak_Specified(Index: Integer): boolean;
  published
    property AcikAdres:   string  Index (IS_OPTN or IS_NLBL) read FAcikAdres write SetAcikAdres stored AcikAdres_Specified;
    property Ada:         string  Index (IS_OPTN or IS_NLBL) read FAda write SetAda stored Ada_Specified;
    property Apartman:    string  Index (IS_OPTN or IS_NLBL) read FApartman write SetApartman stored Apartman_Specified;
    property Bina:        string  Index (IS_OPTN or IS_NLBL) read FBina write SetBina stored Bina_Specified;
    property Blok:        string  Index (IS_OPTN or IS_NLBL) read FBlok write SetBlok stored Blok_Specified;
    property Cadde:       string  Index (IS_OPTN or IS_NLBL) read FCadde write SetCadde stored Cadde_Specified;
    property Daire:       string  Index (IS_OPTN or IS_NLBL) read FDaire write SetDaire stored Daire_Specified;
    property Il:          string  Index (IS_OPTN or IS_NLBL) read FIl write SetIl stored Il_Specified;
    property Ilce:        string  Index (IS_OPTN or IS_NLBL) read FIlce write SetIlce stored Ilce_Specified;
    property Kat:         string  Index (IS_OPTN or IS_NLBL) read FKat write SetKat stored Kat_Specified;
    property Koy:         string  Index (IS_OPTN or IS_NLBL) read FKoy write SetKoy stored Koy_Specified;
    property Mahalle:     string  Index (IS_OPTN or IS_NLBL) read FMahalle write SetMahalle stored Mahalle_Specified;
    property MahalleKodu: string  Index (IS_OPTN or IS_NLBL) read FMahalleKodu write SetMahalleKodu stored MahalleKodu_Specified;
    property Pafta:       string  Index (IS_OPTN or IS_NLBL) read FPafta write SetPafta stored Pafta_Specified;
    property Parsel:      string  Index (IS_OPTN or IS_NLBL) read FParsel write SetParsel stored Parsel_Specified;
    property PostaKodu:   string  Index (IS_OPTN or IS_NLBL) read FPostaKodu write SetPostaKodu stored PostaKodu_Specified;
    property Sayfa:       string  Index (IS_OPTN or IS_NLBL) read FSayfa write SetSayfa stored Sayfa_Specified;
    property Site:        string  Index (IS_OPTN or IS_NLBL) read FSite write SetSite stored Site_Specified;
    property Sokak:       string  Index (IS_OPTN or IS_NLBL) read FSokak write SetSokak stored Sokak_Specified;
  end;



  // ************************************************************************ //
  // XML       : Address, global, <element>
  // Namespace : http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models
  // ************************************************************************ //
  Address = class(Address2)
  private
  published
  end;



  // ************************************************************************ //
  // XML       : CustomerResult, global, <complexType>
  // Namespace : http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models
  // ************************************************************************ //
  CustomerResult2 = class(TRemotable)
  private
    FBirthDate: TXSDateTime;
    FBirthDate_Specified: boolean;
    FCitizenshipNumber: Int64;
    FCitizenshipNumber_Specified: boolean;
    FCustomerNumber: Int64;
    FCustomerNumber_Specified: boolean;
    FEmail: string;
    FEmail_Specified: boolean;
    FGender: Gender;
    FGender_Specified: boolean;
    FGsm: string;
    FGsm_Specified: boolean;
    FName_: string;
    FName__Specified: boolean;
    FPassportNumber: string;
    FPassportNumber_Specified: boolean;
    FPhone: string;
    FPhone_Specified: boolean;
    FSurname: string;
    FSurname_Specified: boolean;
    FTaxNumber: string;
    FTaxNumber_Specified: boolean;
    procedure SetBirthDate(Index: Integer; const ATXSDateTime: TXSDateTime);
    function  BirthDate_Specified(Index: Integer): boolean;
    procedure SetCitizenshipNumber(Index: Integer; const AInt64: Int64);
    function  CitizenshipNumber_Specified(Index: Integer): boolean;
    procedure SetCustomerNumber(Index: Integer; const AInt64: Int64);
    function  CustomerNumber_Specified(Index: Integer): boolean;
    procedure SetEmail(Index: Integer; const Astring: string);
    function  Email_Specified(Index: Integer): boolean;
    procedure SetGender(Index: Integer; const AGender: Gender);
    function  Gender_Specified(Index: Integer): boolean;
    procedure SetGsm(Index: Integer; const Astring: string);
    function  Gsm_Specified(Index: Integer): boolean;
    procedure SetName_(Index: Integer; const Astring: string);
    function  Name__Specified(Index: Integer): boolean;
    procedure SetPassportNumber(Index: Integer; const Astring: string);
    function  PassportNumber_Specified(Index: Integer): boolean;
    procedure SetPhone(Index: Integer; const Astring: string);
    function  Phone_Specified(Index: Integer): boolean;
    procedure SetSurname(Index: Integer; const Astring: string);
    function  Surname_Specified(Index: Integer): boolean;
    procedure SetTaxNumber(Index: Integer; const Astring: string);
    function  TaxNumber_Specified(Index: Integer): boolean;
  public
    destructor Destroy; override;
  published
    property BirthDate:         TXSDateTime  Index (IS_OPTN or IS_NLBL) read FBirthDate write SetBirthDate stored BirthDate_Specified;
    property CitizenshipNumber: Int64        Index (IS_OPTN or IS_NLBL) read FCitizenshipNumber write SetCitizenshipNumber stored CitizenshipNumber_Specified;
    property CustomerNumber:    Int64        Index (IS_OPTN) read FCustomerNumber write SetCustomerNumber stored CustomerNumber_Specified;
    property Email:             string       Index (IS_OPTN or IS_NLBL) read FEmail write SetEmail stored Email_Specified;
    property Gender:            Gender       Index (IS_OPTN) read FGender write SetGender stored Gender_Specified;
    property Gsm:               string       Index (IS_OPTN or IS_NLBL) read FGsm write SetGsm stored Gsm_Specified;
    property Name_:             string       Index (IS_OPTN or IS_NLBL) read FName_ write SetName_ stored Name__Specified;
    property PassportNumber:    string       Index (IS_OPTN or IS_NLBL) read FPassportNumber write SetPassportNumber stored PassportNumber_Specified;
    property Phone:             string       Index (IS_OPTN or IS_NLBL) read FPhone write SetPhone stored Phone_Specified;
    property Surname:           string       Index (IS_OPTN or IS_NLBL) read FSurname write SetSurname stored Surname_Specified;
    property TaxNumber:         string       Index (IS_OPTN or IS_NLBL) read FTaxNumber write SetTaxNumber stored TaxNumber_Specified;
  end;



  // ************************************************************************ //
  // XML       : CustomerResult, global, <element>
  // Namespace : http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models
  // ************************************************************************ //
  CustomerResult = class(CustomerResult2)
  private
  published
  end;



  // ************************************************************************ //
  // XML       : Customer, global, <complexType>
  // Namespace : http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models
  // ************************************************************************ //
  Customer2 = class(TRemotable)
  private
    FAddress: Address2;
    FAddress_Specified: boolean;
    FBirthDate: TXSDateTime;
    FBirthDate_Specified: boolean;
    FBirthPlace: string;
    FBirthPlace_Specified: boolean;
    FBirthPlaceCityCode: Integer;
    FBirthPlaceCityCode_Specified: boolean;
    FCitizenshipNumber: Int64;
    FCitizenshipNumber_Specified: boolean;
    FEmail: string;
    FEmail_Specified: boolean;
    FFatherName: string;
    FFatherName_Specified: boolean;
    FGender: Gender;
    FGender_Specified: boolean;
    FGsm: string;
    FGsm_Specified: boolean;
    FName_: string;
    FName__Specified: boolean;
    FNationality: Integer;
    FNationality_Specified: boolean;
    FPassportNumber: string;
    FPassportNumber_Specified: boolean;
    FPhone: string;
    FPhone_Specified: boolean;
    FSurname: string;
    FSurname_Specified: boolean;
    FTaxNumber: string;
    FTaxNumber_Specified: boolean;
    procedure SetAddress(Index: Integer; const AAddress2: Address2);
    function  Address_Specified(Index: Integer): boolean;
    procedure SetBirthDate(Index: Integer; const ATXSDateTime: TXSDateTime);
    function  BirthDate_Specified(Index: Integer): boolean;
    procedure SetBirthPlace(Index: Integer; const Astring: string);
    function  BirthPlace_Specified(Index: Integer): boolean;
    procedure SetBirthPlaceCityCode(Index: Integer; const AInteger: Integer);
    function  BirthPlaceCityCode_Specified(Index: Integer): boolean;
    procedure SetCitizenshipNumber(Index: Integer; const AInt64: Int64);
    function  CitizenshipNumber_Specified(Index: Integer): boolean;
    procedure SetEmail(Index: Integer; const Astring: string);
    function  Email_Specified(Index: Integer): boolean;
    procedure SetFatherName(Index: Integer; const Astring: string);
    function  FatherName_Specified(Index: Integer): boolean;
    procedure SetGender(Index: Integer; const AGender: Gender);
    function  Gender_Specified(Index: Integer): boolean;
    procedure SetGsm(Index: Integer; const Astring: string);
    function  Gsm_Specified(Index: Integer): boolean;
    procedure SetName_(Index: Integer; const Astring: string);
    function  Name__Specified(Index: Integer): boolean;
    procedure SetNationality(Index: Integer; const AInteger: Integer);
    function  Nationality_Specified(Index: Integer): boolean;
    procedure SetPassportNumber(Index: Integer; const Astring: string);
    function  PassportNumber_Specified(Index: Integer): boolean;
    procedure SetPhone(Index: Integer; const Astring: string);
    function  Phone_Specified(Index: Integer): boolean;
    procedure SetSurname(Index: Integer; const Astring: string);
    function  Surname_Specified(Index: Integer): boolean;
    procedure SetTaxNumber(Index: Integer; const Astring: string);
    function  TaxNumber_Specified(Index: Integer): boolean;
  public
    destructor Destroy; override;
  published
    property Address:            Address2     Index (IS_OPTN or IS_NLBL) read FAddress write SetAddress stored Address_Specified;
    property BirthDate:          TXSDateTime  Index (IS_OPTN or IS_NLBL) read FBirthDate write SetBirthDate stored BirthDate_Specified;
    property BirthPlace:         string       Index (IS_OPTN or IS_NLBL) read FBirthPlace write SetBirthPlace stored BirthPlace_Specified;
    property BirthPlaceCityCode: Integer      Index (IS_OPTN or IS_NLBL) read FBirthPlaceCityCode write SetBirthPlaceCityCode stored BirthPlaceCityCode_Specified;
    property CitizenshipNumber:  Int64        Index (IS_OPTN or IS_NLBL) read FCitizenshipNumber write SetCitizenshipNumber stored CitizenshipNumber_Specified;
    property Email:              string       Index (IS_OPTN or IS_NLBL) read FEmail write SetEmail stored Email_Specified;
    property FatherName:         string       Index (IS_OPTN or IS_NLBL) read FFatherName write SetFatherName stored FatherName_Specified;
    property Gender:             Gender       Index (IS_OPTN) read FGender write SetGender stored Gender_Specified;
    property Gsm:                string       Index (IS_OPTN or IS_NLBL) read FGsm write SetGsm stored Gsm_Specified;
    property Name_:              string       Index (IS_OPTN or IS_NLBL) read FName_ write SetName_ stored Name__Specified;
    property Nationality:        Integer      Index (IS_OPTN or IS_NLBL) read FNationality write SetNationality stored Nationality_Specified;
    property PassportNumber:     string       Index (IS_OPTN or IS_NLBL) read FPassportNumber write SetPassportNumber stored PassportNumber_Specified;
    property Phone:              string       Index (IS_OPTN or IS_NLBL) read FPhone write SetPhone stored Phone_Specified;
    property Surname:            string       Index (IS_OPTN or IS_NLBL) read FSurname write SetSurname stored Surname_Specified;
    property TaxNumber:          string       Index (IS_OPTN or IS_NLBL) read FTaxNumber write SetTaxNumber stored TaxNumber_Specified;
  end;



  // ************************************************************************ //
  // XML       : Customer, global, <element>
  // Namespace : http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models
  // ************************************************************************ //
  Customer = class(Customer2)
  private
  published
  end;


  // ************************************************************************ //
  // Namespace : http://ws.ankarasigorta.com.tr
  // soapAction: http://ws.ankarasigorta.com.tr/ICustomerWS/%operationName%
  // transport : http://schemas.xmlsoap.org/soap/http
  // style     : document
  // use       : literal
  // binding   : BasicHttpBinding_ICustomerWS
  // service   : CustomerWS
  // port      : BasicHttpBinding_ICustomerWS
  // URL       : http://ws.ankarasigorta.com.tr/CustomerWS.svc
  // ************************************************************************ //
  ICustomerWS = interface(IInvokable)
  ['{B6D12213-55D0-78F6-FB9A-7DAA6525070B}']
    function  CreateCustomer(const customer: Customer2): Int64; stdcall;
    function  GetCustomer(const customerNumber: Int64): CustomerResult2; stdcall;
  end;

function GetICustomerWS(UseWSDL: Boolean=System.False; Addr: string=''; HTTPRIO: THTTPRIO = nil): ICustomerWS;


implementation
  uses System.SysUtils;

function GetICustomerWS(UseWSDL: Boolean; Addr: string; HTTPRIO: THTTPRIO): ICustomerWS;
const
  defWSDL = 'https://ws.ankarasigorta.com.tr/CustomerWS.svc?singleWsdl';
  defURL  = 'http://ws.ankarasigorta.com.tr/CustomerWS.svc';
  defSvc  = 'CustomerWS';
  defPrt  = 'BasicHttpBinding_ICustomerWS';
var
  RIO: THTTPRIO;
begin
  Result := nil;
  if (Addr = '') then
  begin
    if UseWSDL then
      Addr := defWSDL
    else
      Addr := defURL;
  end;
  if HTTPRIO = nil then
    RIO := THTTPRIO.Create(nil)
  else
    RIO := HTTPRIO;
  try
    Result := (RIO as ICustomerWS);
    if UseWSDL then
    begin
      RIO.WSDLLocation := Addr;
      RIO.Service := defSvc;
      RIO.Port := defPrt;
    end else
      RIO.URL := Addr;
  finally
    if (Result = nil) and (HTTPRIO = nil) then
      RIO.Free;
  end;
end;


destructor AnkaraFault.Destroy;
var
  I: Integer;
begin
  for I := 0 to System.Length(FErrors)-1 do
    System.SysUtils.FreeAndNil(FErrors[I]);
  System.SetLength(FErrors, 0);
  inherited Destroy;
end;

procedure AnkaraFault.SetErrors(Index: Integer; const AArrayOfErrorInfo: ArrayOfErrorInfo);
begin
  FErrors := AArrayOfErrorInfo;
  FErrors_Specified := True;
end;

function AnkaraFault.Errors_Specified(Index: Integer): boolean;
begin
  Result := FErrors_Specified;
end;

procedure AnkaraFault.SetMessage_(Index: Integer; const Astring: string);
begin
  FMessage_ := Astring;
  FMessage__Specified := True;
end;

function AnkaraFault.Message__Specified(Index: Integer): boolean;
begin
  Result := FMessage__Specified;
end;

procedure ErrorInfo2.SetCode(Index: Integer; const Astring: string);
begin
  FCode := Astring;
  FCode_Specified := True;
end;

function ErrorInfo2.Code_Specified(Index: Integer): boolean;
begin
  Result := FCode_Specified;
end;

procedure ErrorInfo2.SetMessage_(Index: Integer; const Astring: string);
begin
  FMessage_ := Astring;
  FMessage__Specified := True;
end;

function ErrorInfo2.Message__Specified(Index: Integer): boolean;
begin
  Result := FMessage__Specified;
end;

destructor AnkaraFault2.Destroy;
var
  I: Integer;
begin
  for I := 0 to System.Length(FErrors)-1 do
    System.SysUtils.FreeAndNil(FErrors[I]);
  System.SetLength(FErrors, 0);
  inherited Destroy;
end;

procedure AnkaraFault2.SetErrors(Index: Integer; const AArrayOfErrorInfo: ArrayOfErrorInfo);
begin
  FErrors := AArrayOfErrorInfo;
  FErrors_Specified := True;
end;

function AnkaraFault2.Errors_Specified(Index: Integer): boolean;
begin
  Result := FErrors_Specified;
end;

procedure AnkaraFault2.SetMessage_(Index: Integer; const Astring: string);
begin
  FMessage_ := Astring;
  FMessage__Specified := True;
end;

function AnkaraFault2.Message__Specified(Index: Integer): boolean;
begin
  Result := FMessage__Specified;
end;

procedure Address2.SetAcikAdres(Index: Integer; const Astring: string);
begin
  FAcikAdres := Astring;
  FAcikAdres_Specified := True;
end;

function Address2.AcikAdres_Specified(Index: Integer): boolean;
begin
  Result := FAcikAdres_Specified;
end;

procedure Address2.SetAda(Index: Integer; const Astring: string);
begin
  FAda := Astring;
  FAda_Specified := True;
end;

function Address2.Ada_Specified(Index: Integer): boolean;
begin
  Result := FAda_Specified;
end;

procedure Address2.SetApartman(Index: Integer; const Astring: string);
begin
  FApartman := Astring;
  FApartman_Specified := True;
end;

function Address2.Apartman_Specified(Index: Integer): boolean;
begin
  Result := FApartman_Specified;
end;

procedure Address2.SetBina(Index: Integer; const Astring: string);
begin
  FBina := Astring;
  FBina_Specified := True;
end;

function Address2.Bina_Specified(Index: Integer): boolean;
begin
  Result := FBina_Specified;
end;

procedure Address2.SetBlok(Index: Integer; const Astring: string);
begin
  FBlok := Astring;
  FBlok_Specified := True;
end;

function Address2.Blok_Specified(Index: Integer): boolean;
begin
  Result := FBlok_Specified;
end;

procedure Address2.SetCadde(Index: Integer; const Astring: string);
begin
  FCadde := Astring;
  FCadde_Specified := True;
end;

function Address2.Cadde_Specified(Index: Integer): boolean;
begin
  Result := FCadde_Specified;
end;

procedure Address2.SetDaire(Index: Integer; const Astring: string);
begin
  FDaire := Astring;
  FDaire_Specified := True;
end;

function Address2.Daire_Specified(Index: Integer): boolean;
begin
  Result := FDaire_Specified;
end;

procedure Address2.SetIl(Index: Integer; const Astring: string);
begin
  FIl := Astring;
  FIl_Specified := True;
end;

function Address2.Il_Specified(Index: Integer): boolean;
begin
  Result := FIl_Specified;
end;

procedure Address2.SetIlce(Index: Integer; const Astring: string);
begin
  FIlce := Astring;
  FIlce_Specified := True;
end;

function Address2.Ilce_Specified(Index: Integer): boolean;
begin
  Result := FIlce_Specified;
end;

procedure Address2.SetKat(Index: Integer; const Astring: string);
begin
  FKat := Astring;
  FKat_Specified := True;
end;

function Address2.Kat_Specified(Index: Integer): boolean;
begin
  Result := FKat_Specified;
end;

procedure Address2.SetKoy(Index: Integer; const Astring: string);
begin
  FKoy := Astring;
  FKoy_Specified := True;
end;

function Address2.Koy_Specified(Index: Integer): boolean;
begin
  Result := FKoy_Specified;
end;

procedure Address2.SetMahalle(Index: Integer; const Astring: string);
begin
  FMahalle := Astring;
  FMahalle_Specified := True;
end;

function Address2.Mahalle_Specified(Index: Integer): boolean;
begin
  Result := FMahalle_Specified;
end;

procedure Address2.SetMahalleKodu(Index: Integer; const Astring: string);
begin
  FMahalleKodu := Astring;
  FMahalleKodu_Specified := True;
end;

function Address2.MahalleKodu_Specified(Index: Integer): boolean;
begin
  Result := FMahalleKodu_Specified;
end;

procedure Address2.SetPafta(Index: Integer; const Astring: string);
begin
  FPafta := Astring;
  FPafta_Specified := True;
end;

function Address2.Pafta_Specified(Index: Integer): boolean;
begin
  Result := FPafta_Specified;
end;

procedure Address2.SetParsel(Index: Integer; const Astring: string);
begin
  FParsel := Astring;
  FParsel_Specified := True;
end;

function Address2.Parsel_Specified(Index: Integer): boolean;
begin
  Result := FParsel_Specified;
end;

procedure Address2.SetPostaKodu(Index: Integer; const Astring: string);
begin
  FPostaKodu := Astring;
  FPostaKodu_Specified := True;
end;

function Address2.PostaKodu_Specified(Index: Integer): boolean;
begin
  Result := FPostaKodu_Specified;
end;

procedure Address2.SetSayfa(Index: Integer; const Astring: string);
begin
  FSayfa := Astring;
  FSayfa_Specified := True;
end;

function Address2.Sayfa_Specified(Index: Integer): boolean;
begin
  Result := FSayfa_Specified;
end;

procedure Address2.SetSite(Index: Integer; const Astring: string);
begin
  FSite := Astring;
  FSite_Specified := True;
end;

function Address2.Site_Specified(Index: Integer): boolean;
begin
  Result := FSite_Specified;
end;

procedure Address2.SetSokak(Index: Integer; const Astring: string);
begin
  FSokak := Astring;
  FSokak_Specified := True;
end;

function Address2.Sokak_Specified(Index: Integer): boolean;
begin
  Result := FSokak_Specified;
end;

destructor CustomerResult2.Destroy;
begin
  System.SysUtils.FreeAndNil(FBirthDate);
  inherited Destroy;
end;

procedure CustomerResult2.SetBirthDate(Index: Integer; const ATXSDateTime: TXSDateTime);
begin
  FBirthDate := ATXSDateTime;
  FBirthDate_Specified := True;
end;

function CustomerResult2.BirthDate_Specified(Index: Integer): boolean;
begin
  Result := FBirthDate_Specified;
end;

procedure CustomerResult2.SetCitizenshipNumber(Index: Integer; const AInt64: Int64);
begin
  FCitizenshipNumber := AInt64;
  FCitizenshipNumber_Specified := True;
end;

function CustomerResult2.CitizenshipNumber_Specified(Index: Integer): boolean;
begin
  Result := FCitizenshipNumber_Specified;
end;

procedure CustomerResult2.SetCustomerNumber(Index: Integer; const AInt64: Int64);
begin
  FCustomerNumber := AInt64;
  FCustomerNumber_Specified := True;
end;

function CustomerResult2.CustomerNumber_Specified(Index: Integer): boolean;
begin
  Result := FCustomerNumber_Specified;
end;

procedure CustomerResult2.SetEmail(Index: Integer; const Astring: string);
begin
  FEmail := Astring;
  FEmail_Specified := True;
end;

function CustomerResult2.Email_Specified(Index: Integer): boolean;
begin
  Result := FEmail_Specified;
end;

procedure CustomerResult2.SetGender(Index: Integer; const AGender: Gender);
begin
  FGender := AGender;
  FGender_Specified := True;
end;

function CustomerResult2.Gender_Specified(Index: Integer): boolean;
begin
  Result := FGender_Specified;
end;

procedure CustomerResult2.SetGsm(Index: Integer; const Astring: string);
begin
  FGsm := Astring;
  FGsm_Specified := True;
end;

function CustomerResult2.Gsm_Specified(Index: Integer): boolean;
begin
  Result := FGsm_Specified;
end;

procedure CustomerResult2.SetName_(Index: Integer; const Astring: string);
begin
  FName_ := Astring;
  FName__Specified := True;
end;

function CustomerResult2.Name__Specified(Index: Integer): boolean;
begin
  Result := FName__Specified;
end;

procedure CustomerResult2.SetPassportNumber(Index: Integer; const Astring: string);
begin
  FPassportNumber := Astring;
  FPassportNumber_Specified := True;
end;

function CustomerResult2.PassportNumber_Specified(Index: Integer): boolean;
begin
  Result := FPassportNumber_Specified;
end;

procedure CustomerResult2.SetPhone(Index: Integer; const Astring: string);
begin
  FPhone := Astring;
  FPhone_Specified := True;
end;

function CustomerResult2.Phone_Specified(Index: Integer): boolean;
begin
  Result := FPhone_Specified;
end;

procedure CustomerResult2.SetSurname(Index: Integer; const Astring: string);
begin
  FSurname := Astring;
  FSurname_Specified := True;
end;

function CustomerResult2.Surname_Specified(Index: Integer): boolean;
begin
  Result := FSurname_Specified;
end;

procedure CustomerResult2.SetTaxNumber(Index: Integer; const Astring: string);
begin
  FTaxNumber := Astring;
  FTaxNumber_Specified := True;
end;

function CustomerResult2.TaxNumber_Specified(Index: Integer): boolean;
begin
  Result := FTaxNumber_Specified;
end;

destructor Customer2.Destroy;
begin
  System.SysUtils.FreeAndNil(FAddress);
  System.SysUtils.FreeAndNil(FBirthDate);
  inherited Destroy;
end;

procedure Customer2.SetAddress(Index: Integer; const AAddress2: Address2);
begin
  FAddress := AAddress2;
  FAddress_Specified := True;
end;

function Customer2.Address_Specified(Index: Integer): boolean;
begin
  Result := FAddress_Specified;
end;

procedure Customer2.SetBirthDate(Index: Integer; const ATXSDateTime: TXSDateTime);
begin
  FBirthDate := ATXSDateTime;
  FBirthDate_Specified := True;
end;

function Customer2.BirthDate_Specified(Index: Integer): boolean;
begin
  Result := FBirthDate_Specified;
end;

procedure Customer2.SetBirthPlace(Index: Integer; const Astring: string);
begin
  FBirthPlace := Astring;
  FBirthPlace_Specified := True;
end;

function Customer2.BirthPlace_Specified(Index: Integer): boolean;
begin
  Result := FBirthPlace_Specified;
end;

procedure Customer2.SetBirthPlaceCityCode(Index: Integer; const AInteger: Integer);
begin
  FBirthPlaceCityCode := AInteger;
  FBirthPlaceCityCode_Specified := True;
end;

function Customer2.BirthPlaceCityCode_Specified(Index: Integer): boolean;
begin
  Result := FBirthPlaceCityCode_Specified;
end;

procedure Customer2.SetCitizenshipNumber(Index: Integer; const AInt64: Int64);
begin
  FCitizenshipNumber := AInt64;
  FCitizenshipNumber_Specified := True;
end;

function Customer2.CitizenshipNumber_Specified(Index: Integer): boolean;
begin
  Result := FCitizenshipNumber_Specified;
end;

procedure Customer2.SetEmail(Index: Integer; const Astring: string);
begin
  FEmail := Astring;
  FEmail_Specified := True;
end;

function Customer2.Email_Specified(Index: Integer): boolean;
begin
  Result := FEmail_Specified;
end;

procedure Customer2.SetFatherName(Index: Integer; const Astring: string);
begin
  FFatherName := Astring;
  FFatherName_Specified := True;
end;

function Customer2.FatherName_Specified(Index: Integer): boolean;
begin
  Result := FFatherName_Specified;
end;

procedure Customer2.SetGender(Index: Integer; const AGender: Gender);
begin
  FGender := AGender;
  FGender_Specified := True;
end;

function Customer2.Gender_Specified(Index: Integer): boolean;
begin
  Result := FGender_Specified;
end;

procedure Customer2.SetGsm(Index: Integer; const Astring: string);
begin
  FGsm := Astring;
  FGsm_Specified := True;
end;

function Customer2.Gsm_Specified(Index: Integer): boolean;
begin
  Result := FGsm_Specified;
end;

procedure Customer2.SetName_(Index: Integer; const Astring: string);
begin
  FName_ := Astring;
  FName__Specified := True;
end;

function Customer2.Name__Specified(Index: Integer): boolean;
begin
  Result := FName__Specified;
end;

procedure Customer2.SetNationality(Index: Integer; const AInteger: Integer);
begin
  FNationality := AInteger;
  FNationality_Specified := True;
end;

function Customer2.Nationality_Specified(Index: Integer): boolean;
begin
  Result := FNationality_Specified;
end;

procedure Customer2.SetPassportNumber(Index: Integer; const Astring: string);
begin
  FPassportNumber := Astring;
  FPassportNumber_Specified := True;
end;

function Customer2.PassportNumber_Specified(Index: Integer): boolean;
begin
  Result := FPassportNumber_Specified;
end;

procedure Customer2.SetPhone(Index: Integer; const Astring: string);
begin
  FPhone := Astring;
  FPhone_Specified := True;
end;

function Customer2.Phone_Specified(Index: Integer): boolean;
begin
  Result := FPhone_Specified;
end;

procedure Customer2.SetSurname(Index: Integer; const Astring: string);
begin
  FSurname := Astring;
  FSurname_Specified := True;
end;

function Customer2.Surname_Specified(Index: Integer): boolean;
begin
  Result := FSurname_Specified;
end;

procedure Customer2.SetTaxNumber(Index: Integer; const Astring: string);
begin
  FTaxNumber := Astring;
  FTaxNumber_Specified := True;
end;

function Customer2.TaxNumber_Specified(Index: Integer): boolean;
begin
  Result := FTaxNumber_Specified;
end;

initialization
  { ICustomerWS }
  InvRegistry.RegisterInterface(TypeInfo(ICustomerWS), 'http://ws.ankarasigorta.com.tr', 'utf-8');
  InvRegistry.RegisterDefaultSOAPAction(TypeInfo(ICustomerWS), 'http://ws.ankarasigorta.com.tr/ICustomerWS/%operationName%');
  InvRegistry.RegisterInvokeOptions(TypeInfo(ICustomerWS), ioDocument);
  { ICustomerWS.CreateCustomer }
  InvRegistry.RegisterMethodInfo(TypeInfo(ICustomerWS), 'CreateCustomer', '',
                                 '[ReturnName="CreateCustomerResult"]', IS_OPTN or IS_NLBL);
  InvRegistry.RegisterParamInfo(TypeInfo(ICustomerWS), 'CreateCustomer', 'customer', '',
                                '[Namespace="http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models"]', IS_NLBL);
  InvRegistry.RegisterParamInfo(TypeInfo(ICustomerWS), 'CreateCustomer', 'CreateCustomerResult', '',
                                '', IS_NLBL);
  { ICustomerWS.GetCustomer }
  InvRegistry.RegisterMethodInfo(TypeInfo(ICustomerWS), 'GetCustomer', '',
                                 '[ReturnName="GetCustomerResult"]', IS_OPTN or IS_NLBL);
  InvRegistry.RegisterParamInfo(TypeInfo(ICustomerWS), 'GetCustomer', 'GetCustomerResult', '',
                                '[Namespace="http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models"]', IS_NLBL);
  RemClassRegistry.RegisterXSInfo(TypeInfo(Gender), 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models', 'Gender');
  RemClassRegistry.RegisterXSInfo(TypeInfo(ArrayOfErrorInfo), 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.Core.WS', 'ArrayOfErrorInfo');
  RemClassRegistry.RegisterXSClass(AnkaraFault, 'http://ws.ankarasigorta.com.tr', 'AnkaraFault');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(AnkaraFault), 'Errors', '[ArrayItemName="ErrorInfo"]');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(AnkaraFault), 'Message_', '[ExtName="Message"]');
  RemClassRegistry.RegisterXSClass(ErrorInfo2, 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.Core.WS', 'ErrorInfo2', 'ErrorInfo');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(ErrorInfo2), 'Message_', '[ExtName="Message"]');
  RemClassRegistry.RegisterXSClass(ErrorInfo, 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.Core.WS', 'ErrorInfo');
  RemClassRegistry.RegisterXSClass(AnkaraFault2, 'http://ws.ankarasigorta.com.tr', 'AnkaraFault2', 'AnkaraFault');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(AnkaraFault2), 'Errors', '[ArrayItemName="ErrorInfo"]');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(AnkaraFault2), 'Message_', '[ExtName="Message"]');
  RemClassRegistry.RegisterXSClass(Address2, 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models', 'Address2', 'Address');
  RemClassRegistry.RegisterXSClass(Address, 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models', 'Address');
  RemClassRegistry.RegisterXSClass(CustomerResult2, 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models', 'CustomerResult2', 'CustomerResult');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(CustomerResult2), 'Name_', '[ExtName="Name"]');
  RemClassRegistry.RegisterXSClass(CustomerResult, 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models', 'CustomerResult');
  RemClassRegistry.RegisterXSClass(Customer2, 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models', 'Customer2', 'Customer');
  RemClassRegistry.RegisterExternalPropName(TypeInfo(Customer2), 'Name_', '[ExtName="Name"]');
  RemClassRegistry.RegisterXSClass(Customer, 'http://schemas.datacontract.org/2004/07/AnkaraSigorta.ExtApps.WS.Models', 'Customer');

end.