unit utest;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Soap.InvokeRegistry, System.Net.URLClient, Soap.Rio, Soap.SOAPHTTPClient,
  Soap.SOAPHTTPTrans, System.Net.HttpClient,
 CustomerWS, WSSE;

type
  TForm1 = class(TForm)
    tckimlikedit: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    musterinoedit: TEdit;
    HTTPRIO1: THTTPRIO;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  MusteriWS   : CustomerWS.ICustomerWS;
  Musteri     : CustomerWS.Customer;
  LNewCustNo    : Int64;
  LHeader       : Security;
  LHeaders      : ISOAPHeaders;
begin

  //try
    HTTPRIO1.HTTPWebNode.UserName := 'test';
    HTTPRIO1.HTTPWebNode.Password := 'test';

    MusteriWS := CustomerWS.GetICustomerWS( True, '', HTTPRIO1 );

    LHeader      := WSSE.Security.Create;
    LHeader.MustUnderstand  := True;

    LHeader.UsernameToken   := WSSE.UsernameToken.Create;
      LHeader.UsernameToken.Username        := HTTPRIO1.HTTPWebNode.UserName;
      LHeader.UsernameToken.Password        := WSSE.Password.Create;
      LHeader.UsernameToken.Password.Type_  := 'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-username-token-profile-1.0#PasswordText';
      LHeader.UsernameToken.Password.Text   := HTTPRIO1.HTTPWebNode.Password;

    HTTPRIO1.SOAPHeaders.Send( LHeader );


    Musteri     := CustomerWS.Customer.Create;
    Musteri.CitizenshipNumber := strtoInt64(tckimlikedit.Text);

    LNewCustNo  := MusteriWS.CreateCustomer(Musteri );

    ShowmessageFmt('%d', [ LNewCustNo ]);
  {except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;  }


end;

end.
